//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Fiche1.h"
#include "Diseqc12.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"
TForm1 *Form1;

char  HexaToChar(char hex_digit); // Conversion digit hexa => sa valeur binaire
String lignesat;
char numerosat;
int level;

extern TProgAPISignalState state;
extern TProgAPIDiSEqCmd cmdDiseqc;
extern TProgAPIGetChannelName  getChannelName;
extern struct TTransponder TPtp;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void affich_niveau_reception(void)
{  level=PROG_Get_Signal_Level();
   Form1->NiveauBarre->Position=level;
   Form1->Niveau->Text=level;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EnvoiCommandeClick(TObject *Sender)
{  int i;
   char hexahaut,hexabas;
   for (i=1;i<=4;i++)
     {  //if (!isxdigit(*Commande->Text.SubString((i-1)*3+1,1).c_str())) break;
        hexahaut=*Commande->Text.SubString((i-1)*3+1,1).c_str();
        hexabas =*Commande->Text.SubString((i-1)*3+2,1).c_str();
        cmdDiseqc.Cmd[i-1]=(char)(HexaToChar(hexahaut)*16+HexaToChar(hexabas));
     }
    cmdDiseqc.dwCmdLength=i-1;
    PROG_Send_Diseqc();
    affich_niveau_reception();

}
//---------------------------------------------------------------------------

// Conversion d'un digit hexa en sa valeur binaire
char  HexaToChar(char hex_digit)
{  char table[16] ={ '\x00','\x01','\x02','\x03','\x04','\x05','\x06','\x07',
                    '\x08','\x09','\x0A','\x0B','\x0C','\x0D','\x0E','\x0F' };

   if( hex_digit>='0' && hex_digit<='9' ) return table[hex_digit-'0'];
   if( hex_digit>='A' && hex_digit<='F' ) return table[hex_digit-'A'+10];
   return table[0];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SecondWestClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
   cmdDiseqc.Cmd[3]=(char)Duree->Value;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SecondEastClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
   cmdDiseqc.Cmd[3]=(char)Duree->Value;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::StepWestClick(TObject *Sender)
{   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
   cmdDiseqc.Cmd[3]=(char)-Step->Value;  // 1 byte sign moins
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StepEastClick(TObject *Sender)
{    strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
   cmdDiseqc.Cmd[3]=(char)-Step->Value;   // 1 byte sign moins
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoutonOuestMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoutonOuestMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{  BoutonStopClick(Sender);
  affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoutonEstMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
  cmdDiseqc.dwCmdLength='\x04';
  PROG_Send_Diseqc();
  affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoutonEstMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{  BoutonStopClick(Sender);
  affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BoutonStopClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x60");
  cmdDiseqc.dwCmdLength='\x03';
  PROG_Send_Diseqc();
  affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButeeOuestClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x67\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButeeEstClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x66\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DeactButeeClick(TObject *Sender)
{    strcpy(cmdDiseqc.Cmd,"\xE0\x31\x63\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GoToSatClick(TObject *Sender)
{   lignesat= ListeSat->Items->Strings[ListeSat->ItemIndex];
   numerosat=(char)lignesat.SubString(1,2).ToInt();
   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6B\x00");
   cmdDiseqc.Cmd[3]=numerosat;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StoreSatClick(TObject *Sender)
{  lignesat= ListeSat->Items->Strings[ListeSat->ItemIndex];
   numerosat=(char)lignesat.SubString(1,2).ToInt();
   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6A\x00");
   cmdDiseqc.Cmd[3]=numerosat;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------





void __fastcall TForm1::FormDeactivate(TObject *Sender)
{  StoreSatClick(Sender);
   Form1->Close(); 
}
//---------------------------------------------------------------------------

