//---------------------------------------------------------------------------
#include <vcl.h>
#include <fstream.h>
#pragma hdrstop
#include "Diseqc12.h"
#include "Fiche1.h"        
#include "Settings.h"
USEFORM("Fiche1.cpp", Form1);
USEDEF("Diseqc12.def");
USERC("menu.rc");
USERES("Diseqc12.res");
USEFORM("Settings.cpp", Form2);
//---------------------------------------------------------------------------
HINSTANCE ProgDVDInstance;         // Handle to calling program (ProgDVB)
HWND      ProgDVDWindow;           // HWND of calling window
TProgAPISignalState state;
TProgAPIDiSEqCmd cmdDiseqc;
bool autodrive=false;
extern void affich_niveau_reception(void);

int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//---------------------------------------------------------------------------
void On_Start(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set, int DLL_ID,
              char *My_Hot_Key,char *Api_Version, int *Keep_me_running )

{ ProgDVDInstance=MDInstance;
  ProgDVDWindow  =MDWnd;
  Form1=new TForm1(NULL);
  Form2=new TForm2(NULL);
  if (FileExists("\diseqc12.ini"))
    Form1->ListeSat->Items->LoadFromFile("\diseqc12.ini");
   else ShowMessage("Fichier diseqc.ini non trouv !");
  if (Form1->ListeSat->Items->Strings[1].SubString(1,13)=="Autodrive=YES")
    { autodrive=true;
      Form2->CBAutoDrive->Checked=true;
     }
   else
    { autodrive=false;
      Form2->CBAutoDrive->Checked=false;
    }
}
//---------------------------------------------------------------------------
void On_Exit(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set)
{
   Form1->ListeSat->Items->SaveToFile("\diseqc12.ini");
}
//---------------------------------------------------------------------------
void On_Menu_Select(unsigned int MenuID )
{  switch(MenuID)
    { /*case 40701 :                      // Auto-drive  */
      case 40703 :                      // Set up Diseqc 1.2
        Form2->ShowModal();
        break;
      case 40705 :                      // Commandes moteur
        Form1->Show();
        break;
      case 40709:                       // About Diseqc12
         ShowMessage("Diseqc 1.2 plugin by parabolus\n\n"
                     "Test sous Windows XP avec carte Hauppauge Nexus\n\n"
                     "et moteur STAB HH10 ou moteur METRONIC 450908\n\n"
                     "et ProgDVB version 4.10.3");
        break;
     }
}
//---------------------------------------------------------------------------
int PROG_Get_Signal_Level( void )
{  state.dwSize=sizeof(state);
   SendMessage(ProgDVDWindow,WM_USER,PROGAPI_GET_SIGNAL_LEVEL,DWORD(&state));
   return  state.dwLevel;
}
//---------------------------------------------------------------------------
int PROG_Send_Diseqc( void)
{  cmdDiseqc.dwSize=sizeof(cmdDiseqc);
   return SendMessage(ProgDVDWindow,WM_USER,PROGAPI_SEND_DISEQC,DWORD(&cmdDiseqc));
}
//---------------------------------------------------------------------------
void On_Channel_Change( struct TProgramm82 CurrentProgramm )
{  String lgsat; // longitude sat sous la forme xxx.x E ou xxx.x W
   String lignesat,s;
   unsigned short int longitude3600;
   char numerosat;
   int iboucle;

   unsigned char octetfaible=CurrentProgramm.Extern_Buffer[0];
   unsigned char octetfort=CurrentProgramm.Extern_Buffer[1];
   longitude3600=octetfort*256+octetfaible;
   if (longitude3600<1800) lgsat=IntToStr(longitude3600) + " E";
    else  lgsat=IntToStr(3600-longitude3600) + " W";
   lgsat=lgsat.Insert(".",lgsat.Length()-2);
   for(iboucle=3;iboucle<Form1->ListeSat->Items->Count;iboucle++) //by-pass 3 lignes titre
     { s = Form1->ListeSat->Items->Strings[iboucle].SubString(4,7);
       s=s.TrimLeft();                  // suppression espaces en tte
       if (lgsat==s)                    // if sat longitude found in table
         { Form1->ListeSat->ItemIndex=iboucle;
           if (autodrive)
             { lignesat= Form1->ListeSat->Items->Strings[Form1->ListeSat->ItemIndex];
               numerosat=(char)lignesat.SubString(1,2).ToInt();
               strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6B\x00");
               cmdDiseqc.Cmd[3]=numerosat;
               cmdDiseqc.dwCmdLength='\x04';
               PROG_Send_Diseqc();
             }
           break;
         }
     }
   if (iboucle==Form1->ListeSat->Items->Count)
    ShowMessage("longitude satellite "+IntToStr(longitude3600)+" inconnue dans diseqc.ini !");
    affich_niveau_reception();

}
//---------------------------------------------------------------------------

